unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,  httpsend, ext_fun, inifiles, TlHelp32, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    Edit2: TEdit;
    Label2: TLabel;
    CheckBox2: TCheckBox;
    Label4: TLabel;
    Edit3: TEdit;
    Label5: TLabel;
    Label3: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    GroupBox1: TGroupBox;
    Button2: TButton;
    Timer1: TTimer;
    Label8: TLabel;
    Label9: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure obrabotchik;
    procedure Memo1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Edit2Change(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;


type
  Potok_class = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  end;


var
  Form1: TForm1;
  IDPotok_class: Potok_class;
  count_pokot_end   : integer = 0;
  isrunning         : bool = false;
  glob_mess: string;

implementation

{$R *.dfm}

uses ZLibExGZ, synautil;

procedure TForm1.obrabotchik;
begin
  inc (count_pokot_end);
  form1.Memo1.Lines.Add(' '+inttostr(count_pokot_end)+' . : '+glob_mess);

  form1.Label4.Caption :=  inttostr(count_pokot_end);
end;


procedure Potok_class.Execute;
var
  URLData: string;
  HTTP: THTTPSend;
  temp, cook, ansfer, date : string;
  potoknum : integer;
  str : string;
  strlist : tstringlist;

begin
  HTTP := THTTPSend.Create;


  try


      if form1.CheckBox2.Checked then begin
        http.ProxyHost := form1.Edit4.Text;
        http.ProxyPort := form1.Edit5.Text;
      end;

      HTTP.AddPortNumberToHost:=false;
      HTTP.UserAgent := 'Mozilla/5.0 (Windows NT 5.1; rv:7.0.1) Gecko/20100101 Firefox/7.0.1';
      HTTP.Headers.Add('Accept-Encoding: gzip,deflate');//
      HTTP.Protocol:='1.1';//   1.0

      HTTP.HTTPMethod('GET', Form1.Edit3.Text);

      if HTTP.Headers.Count > 0
        then ansfer := HTTP.Headers[0]
        else ansfer :=  '<>';


      //    (  )
      if form1.CheckBox1.Checked then begin

        //     
        HeadersToList(http.Headers); //  ,      
        if trim(http.Headers.Values['Content-Encoding']) = 'gzip' then //      
        begin
       //   form1.Memo1.Lines.Add('    ');
          str := ReadStrFromStream(http.Document, http.Document.Size); //   
          str := GZDecompressStr(str); //  
        end else begin
          str := StreamToString(http.Document);
        end;

        randomize;
        temp := inttostr(random(100));
        DateTimeToString(date, 'dd.MM.yyyy HH-mm-ss', now());

        strlist := tstringlist.Create ;
        strlist.Text := str ;
        strlist.SaveToFile(date+temp+' http_body.txt');
        strlist.free;

        HTTP.Headers.SaveToFile (date+temp+' http_head.txt');
      end;

      glob_mess := ansfer;
      synchronize(form1.obrabotchik);

  finally
    HTTP.Free;


  end;



end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  memo1.Clear;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
  MemoDelLastNL(memo1);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
 configini: TIniFile;

begin

  try
  configini := TIniFile.Create(ExtractFilePath(Application.ExeName)+'config.ini');

  configini.WriteBool  ('General', 'UseProxy', Form1.CheckBox2.Checked);
  configini.WriteString('General', 'ProxyIP',  Form1.edit4.Text);
  configini.WriteString('General', 'ProxyPort', Form1.edit5.Text);
  configini.WriteString('General', 'URL',      Form1.edit3.Text);
  configini.WriteString('General', 'Theards',  Form1.edit1.Text);
  configini.WriteString('General', 'Sleep',    Form1.edit2.Text);
  configini.WriteBool  ('General', 'WriteToFile', Form1.CheckBox1.Checked);

  configini.Free;

  except
    Memo1.Lines.Add('!  "config.ini" .') ;
  end;

end;



procedure TForm1.FormCreate(Sender: TObject);
var
  ini: TIniFile;
begin
form1.Caption :=   form1.Caption + ' v.1.3.1';
     ini := TIniFile.Create(ExtractFilePath(Application.ExeName)+'config.ini');

  Form1.CheckBox2.Checked     :=  ini.ReadBool  ('General', 'UseProxy', true);
  Form1.edit4.Text            :=  ini.ReadString('General', 'ProxyIP', '');
  Form1.edit5.Text            :=  ini.ReadString('General', 'ProxyPort', '');
  Form1.edit3.Text            :=  ini.ReadString('General', 'URL', '');
  Form1.edit1.Text            :=  ini.ReadString('General', 'Theards', '150');
  Form1.edit2.Text            :=  ini.ReadString('General', 'Sleep', '50');
  Form1.CheckBox1.Checked     :=  ini.ReadBool  ('General', 'WriteToFile', true);

  ini.Free;

  timer1.Interval :=  strtoint(Form1.edit2.Text);

end;




function GetThreadsCount(const ProcessID: DWORD): Integer;
var
  hThreadsSnap: HWND;
  Threads: TThreadEntry32;
begin
  Result := 0;
  hThreadsSnap := CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0);
  if hThreadsSnap <> INVALID_HANDLE_VALUE then
  try
    Threads.dwSize := SizeOf(TThreadEntry32);
    if Thread32First(hThreadsSnap, Threads) then
    repeat
      Inc(Result, Integer(Threads.th32OwnerProcessID = ProcessID));
    until not Thread32Next(hThreadsSnap, Threads);
  finally
    CloseHandle(hThreadsSnap);
  end;
end;
 


procedure TForm1.Button2Click(Sender: TObject);
begin

if isrunning then begin
  // 
  isrunning := false;
  Button2.Caption := '';
end else begin //   
  // 
  isrunning := true;
  Button2.Caption := '';
end

end;



procedure TForm1.Timer1Timer(Sender: TObject);
var potoki: integer;
begin

   try
     potoki := strtoint(Form1.edit1.Text) ;
   except
     Form1.edit1.Text := '0';
     potoki := 0 ;
   end ;

   label9.Caption := inttostr(GetThreadsCount(GetCurrentProcessId)-1) ;

   if isrunning then
     if ( GetThreadsCount(GetCurrentProcessId) < potoki ) then
       IDPotok_class := Potok_class.Create(False);

end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  timer1.Interval :=  strtoint(Form1.edit2.Text);
end;

end.


