///   v.1.2
unit ext_fun;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;


function poss(str, whot:string):integer;
function get(text, start_, end_:string):string;
function my_convert(ws: widestring): string;
function get_int(text, start_ ,end_ :string; entr: integer) : string;
procedure writelog1(s: string; name: string='');
function StreamToString(aStream: TStream): string;
function URLEncode(const S3: string): string;
function HTMLCharsToStr(strDoc: string): String;
function HTMLBeautiful(strDoc: string): String;
function ExtractFileNameWOExt(s: string): string;
procedure MemoDelLastNL (Memo: TMemo);


implementation





procedure writelog1(s: string; name: string='');
var
  f:TStrings;
  filename, temp: string;
 //  tt :tdatetime;
begin
 if name=''
  then filename:= ExtractFilePath(Application.ExeName)+'log.txt'
  else filename:= ExtractFilePath(Application.ExeName)+name;
 f:= TStringList.Create();
// tt := now();
 if fileexists(filename) then f.LoadFromFile(filename);
 DateTimeToString(temp, 'dd.MM.yyyy HH:mm:ss', now());
 f.Add(temp+' > '+s);
 f.SaveToFile(filename);
 f.Free;
end;


function poss(str, whot:string):integer;
var i:integer;
begin
result:=-1;
for i:=1 to length(str) do
if copy(str,i,length(whot))=whot then
 begin
   result:=i;
   break;
 end;
end;


function get(text,start_,end_:string):string;
var sP,eP:integer;
begin
result:='?';
sP:=poss(text,start_);
  if sP<0 then exit;
text:=copy(text,sP+length(start_),length(text));
eP:=poss(text,end_)-1;
  if eP<0 then exit;
result:=copy(text,1,ep);
end;


function my_convert(ws: widestring): string;
var
  i     : integer  ;
  s, s2 : string   ;
begin
Result:='';
s:=UTF8toansi(ws);
for i:=2 to length(s) do
  if  s[i]=#$A then s2 := s2 + #13#10 else s2 := s2 + s[i];
Result:=s2;
end;






function get_int(text, start_ ,end_ :string; entr: integer) : string;
var
  sP,eP,i:integer;
begin
result:='?';
i:=0;
repeat
sP:=poss(text,start_);
  if sP<0 then begin
    result:='?';
    exit;
  end;
text:=copy(text,sP+length(start_),length(text));
eP:=poss(text,end_)-1;
  if eP<0 then begin
    result:='?';
    exit;
  end;
result:=copy(text,1,ep);
delete(text,1,1);
inc(i);
until i>=entr
end;

  function StreamToString(aStream: TStream): string;
  var
    SS: TStringStream;
  begin
    if aStream <> nil then
    begin
      SS := TStringStream.Create('');
      try
        aStream.Position := 0;
        SS.CopyFrom(aStream, aStream.Size);
        Result := SS.DataString;
      finally
        SS.Free;
      end;
    end else
    begin
      Result := '';
    end;
  end;

function URLEncode(const S3: string): string;
var
  Idx: Integer;
begin
  Result := '';
  for Idx := 1 to Length(S3) do
  begin
    if S3[Idx] in ['A'..'Z', 'a'..'z', '0'..'9', '-', '=', '&', ':', '/', '?', ';', '_', '.'] then
        Result := Result + S3[Idx]
    else
      Result := Result + '%' + IntToHex(Ord(S3[Idx]), 2);
  end;
end;


//   &#0000;&#0000;&#0000;  ..
function HTMLCharsToStr(strDoc: string): String;
var
  i: integer;
begin
  Result:='';
  i:=1;
  while i<=length(strDoc) do begin
   if Copy(strDoc,i,2)='&#' then begin
     Result:=Result+WideChar(StrToInt(Copy(strDoc,i+2,4)));
     inc(i,6);
   end
   else Result:=Result+strDoc[i];
   inc(i);
  end;
end;


function HTMLBeautiful(strDoc: string): String;
begin
  result := StringReplace(strDoc, '<br>', #13#10, [rfReplaceAll]);
  result := StringReplace(result, '&nbsp;', ' ', [rfReplaceAll]);
  result := StringReplace(result, '&amp;', '&', [rfReplaceAll]);
  result := StringReplace(result, '&quot;', '"', [rfReplaceAll]);
  result := StringReplace(result, '&gt;', '>', [rfReplaceAll]);
  result := StringReplace(result, #10, '', [rfReplaceAll]);
  result := StringReplace(result, #13#10, '', [rfReplaceAll]);
end;


function ExtractFileNameWOExt(s: string): string;
begin
  result := ExtractFileName(s);
  delete( result,
         Length(result)-length(ExtractFileExt(result))+1,
         Length(ExtractFileExt(result)) );
end;



procedure MemoDelLastNL (Memo: TMemo);
var
i : integer;
begin
i:=GetWindowTextLength(Memo.Handle);
Memo.SelStart:=i-2;
Memo.SelLength:=2;
if Memo.SelText = #13#10 then
  Memo.SelText:=''
else
  Memo.SelStart:=i;
end;



end.
